// Console_Cpp_ApiTest.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include "pch.h"
#include <iostream>
#include <string>
#include <basetsd.h>
#include "pcmcat_api.h"

void __stdcall static_pcmcat_api_callback(void *context, pcmcat_api_callback_data_t *pcmcat_api_callback_data);

int main()
{
	std::string input_str;
	double set_value;
	double get_value;

	if (0 == pcmcat_api_open(static_pcmcat_api_callback, NULL))
	{
		std::cout << "Connection Open\n";
		std::cout << "Introduce the number you want VR(0) to be set to-> ";
		std::cin >> input_str;

		set_value = (double)atof(input_str.c_str());

		if (0 == pcmcat_api_set_vr(0,1,&set_value))
		{
			std::cout << "VR(0) Written -> " << set_value << "\n";
			
			if (0 == pcmcat_api_get_vr(0,1,&get_value))
			{
				std::cout << "VR(0) Read-> "<< get_value <<"\n";
				if ((get_value - set_value) < DBL_EPSILON)
					std::cout << "VR(0) has been written correctly\n";
				else
					std::cout << "VR(0) written and read values don't match\n";
			}
			else
			{
				std::cout << "Error reading VR(0)\n";
			}
		}
		else
		{
			std::cout << "Error writting VR(0)\n";
		}
	}
	else
	{
		std::cout << "Connection Not Open\n";
	}
	pcmcat_api_close();
	std::cout << "----- Press 'x' plus Enter to exit -----\n";
	while (input_str != "x")
		std::cin >> input_str;
}

void __stdcall static_pcmcat_api_callback(void *context, pcmcat_api_callback_data_t *pcmcat_api_callback_data)
{
	if (!pcmcat_api_callback_data)
		return;

	switch (pcmcat_api_callback_data->type)
	{
	case pcmcat_api_callback_type_message:
		if (pcmcat_api_callback_data->data.str)
			std::cout << pcmcat_api_callback_data->data.str << "\n";
	}
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
