﻿Imports System.Runtime.InteropServices
Imports TrioMotion.PCMCAT

Public Class Form1
    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        If PCMCAT_API.Open(AddressOf CallbackFunction, IntPtr.Zero) = 0 Then
            MessageBox.Show("PC-MCAT API .Net assembly opened connection correctly")
        Else
            MessageBox.Show("Error opening the PC-MCAT API .Net assembly connection")
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        PCMCAT_API.Close()
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        If PCMCAT_API.SetVR(0, Double.Parse(TextBox1.Text)) <> 0 Then
            MessageBox.Show("Error setting VR(0) to " + TextBox1.Text)
        End If
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        Dim vr0 As Double
        If PCMCAT_API.GetVR(0, vr0) <> 0 Then
            MessageBox.Show("Error getting VR(0)")
        Else
            TextBox2.Text = vr0.ToString()
        End If
    End Sub

    Private Sub CallbackFunction(Context As IntPtr, ByRef Data As PCMCAT_API.CallbackData)
        Select Case Data.Type
            Case PCMCAT_API.CallbackType.Message
                MessageBox.Show(Marshal.PtrToStringAnsi(Data.Data.Str))
        End Select
    End Sub
End Class
